'T13_DA10_2.bas
'Ansteurung eines seriellen 10-Bit-DA-Wandlers MAX515
$regfile = "attiny13.dat"
$crystal = 1200000
Baud = 9600

Dim Daten As Byte
Dim Da_hi As Byte
Dim Da_lo As Byte
Dim I As Byte
Dim Din_dt As Byte


Open "comb.1:9600,8,n,1,INVERTED" For Output As #1
Open "comb.2:9600,8,n,1,inverted" For Input As #2

Din Alias Portb.3                                           'Pins des MAX515
Cs Alias Portb.4
Sclk Alias Portb.0
Config Portb.3 = Output
Config Portb.4 = Output
Config Portb.0 = Output
Din = 1
Cs = 1
Sclk = 0

Do
Auswahl:
Get #2 , Daten
If Daten = 248 Then                                         ' nur bei 248 Sprung nach Weiter
Goto Weiter
End If
Goto Auswahl

Weiter:
Reset Cs
Get #2 , Daten
Da_hi = Daten
Get #2 , Daten
Da_lo = Daten

Din_dt = Da_hi And 2                                        ' nur Bit 0 und 1
Shift Din_dt , Right                                        'Bit 9
Gosub Bitaus

Din_dt = Da_hi And 1                                        'Bit 8
Gosub Bitaus

Schieben:
For I = 0 To 7                                              'war 7
Din_dt = Da_lo And 128                                      '!
Din_dt = Din_dt / 128
Gosub Bitaus
Shift Da_lo , Left                                          '!
Next I


Reset Sclk                                                  ' 2 Dummy-Bits
Waitms 2
Reset Din
Waitms 2
Set Sclk
Reset Sclk
Waitms 2
Set Sclk

Set Cs
Waitms 2
Set Sclk
Waitms 2
Set Din
Loop

Bitaus:
If Din_dt = 0 Then

Reset Sclk
Waitms 2
Reset Din
Waitms 2
Set Sclk
End If

If Din_dt = 1 Then
Reset Sclk
Waitms 2
Set Din
Waitms 2
Set Sclk
End If
Return


End